USE AdventureWorks2014

--Create and populate the tables
--Note the number of rows
	CREATE TABLE #temp
			(TransactionID INT,
			 TempValue	   INT)

	INSERT #temp (TransactionID, TempValue)
	SELECT TOP 100000 TransactionID, 1
	FROM Production.TransactionHistory;
	GO
	INSERT #temp (TransactionID, TempValue)
	SELECT TOP 10000 TransactionID, 2
	FROM Production.TransactionHistory;
	GO

--***********************************************
--Note no statistics

	USE tempdb;
	GO
	SELECT
	sp.stats_id, name, last_updated, rows, rows_sampled, steps, unfiltered_rows, modification_counter
	FROM sys.stats AS stat
	CROSS APPLY sys.dm_db_stats_properties(stat.object_id, stat.stats_id) AS sp
	WHERE stat.object_id = object_id('#temp');
	GO

--***********************************************

	--Query the new table
	USE AdventureWorks2014
	SELECT MAX(th.Quantity)
	FROM #temp as t
	 INNER JOIN Production.TransactionHistory th 
		ON t.TransactionID=th.TransactionID
	WHERE TempValue=2;
	GO


--*********************************************

--Note statistics found
	USE tempdb;
	GO
	SELECT
	sp.stats_id, name, last_updated, rows, rows_sampled, steps, unfiltered_rows, modification_counter
	FROM sys.stats AS stat
	CROSS APPLY sys.dm_db_stats_properties(stat.object_id, stat.stats_id) AS sp
	WHERE stat.object_id = object_id('#temp');
	GO

--********************************************************
--Get the Statistics name from the previous statement
--Note the All Density
	USE tempdb
	DBCC SHOW_STATISTICS('#temp', '_WA_Sys_00000002_B82A2037')

--****************************************************

--Add a third option
--Note percentage of rows that are modified
USE AdventureWorks2014
INSERT #temp (TransactionID, TempValue)
SELECT TOP 100 TransactionID, 3
FROM Production.TransactionHistory;
GO

--******************************************

--*********************************************

--Note statistics found
--Note Modification Counter
	USE tempdb;
	GO
	SELECT
	sp.stats_id, name, last_updated, rows, rows_sampled, steps, unfiltered_rows, modification_counter
	FROM sys.stats AS stat
	CROSS APPLY sys.dm_db_stats_properties(stat.object_id, stat.stats_id) AS sp
	WHERE stat.object_id = object_id('#temp');
	GO

--********************************************************
--Get the Statistics name from the previous statement
--Note the All Density
	USE tempdb
	DBCC SHOW_STATISTICS('#temp', '_WA_Sys_00000002_B82A2037')

--********************************************************

	USE AdventureWorks2014
	SELECT max(th.Quantity)
	FROM #temp as t
	JOIN Production.TransactionHistory th on t.TransactionID=th.TransactionID
	WHERE TempValue=3;
	GO

--******************************************************

--Get Statistics Name
--Note All density
	USE tempdb
	DBCC SHOW_STATISTICS('#temp', '_WA_Sys_00000002_B0FB1F3D')

--******************************************************

--Updates all statictics
	USE tempdb 
	UPDATE STATISTICS #temp([_WA_Sys_00000002_B0FB1F3D]) 

--******************************************************

--Get Statistics Name
--Note All density
	USE tempdb
	DBCC SHOW_STATISTICS('#temp', '_WA_Sys_00000002_B0FB1F3D')
 
