
--Shows how SQL Server will create stats
--on a column that is the second column
--of a multi column stats

SET STATISTICS TIME ON 
PRINT 'SET STATS TIME  ON========================================'

	DROP STATISTICS sales.[SalesOrderDetail]._WA_Sys_00000006_44CA3770
	DROP STATISTICS sales.[SalesOrderDetail]._WA_Sys_00000007_44CA3770
	DROP STATISTICS sales.[SalesOrderDetail]._WA_Sys_00000008_44CA3770
	DROP STATISTICS sales.[SalesOrderDetail].[DiscAndUnitPrice]

PRINT 'DROP STATISTICS ==========================================='

	ALTER DATABASE AdventureWorks2014
	SET AUTO_CREATE_STATISTICS ON
	GO

PRINT 'ALTER DATABASE TURN ON====================================='

	SELECT	  c.CustomerID
			, c.AccountNumber
	FROM sales.Customer c
		INNER JOIN [Sales].[SalesOrderHeader] o
			ON c.CustomerID = o.CustomerID
		INNER JOIN [Sales].[SalesOrderDetail] od
			ON o.SalesOrderID = od.salesOrderID
		INNER JOIN [Production].[Product] p
			ON od.ProductID = p.ProductID
	WHERE c.modifieddate = '2014-09-12 11:15:07.263'
			AND UnitPriceDiscount <> 0
				AND od.unitprice < 6000

PRINT 'Query No Stats====================================='

	USE [AdventureWorks2014]
	GO

PRINT 'Change Databases====================================='

	DROP STATISTICS sales.[SalesOrderDetail]._WA_Sys_00000006_44CA3770
	DROP STATISTICS sales.[SalesOrderDetail]._WA_Sys_00000007_44CA3770
	DROP STATISTICS sales.[SalesOrderDetail]._WA_Sys_00000008_44CA3770
	DROP STATISTICS sales.[SalesOrderDetail].[DiscAndUnitPrice]

PRINT 'DROP STATISTICS====================================='

	CREATE STATISTICS [DiscAndUnitPrice] 
	ON [Sales].[SalesOrderDetail]([UnitPrice], [UnitPriceDiscount])
	GO

PRINT 'CREATE STATISTICS====================================='
	ALTER DATABASE AdventureWorks2014
	SET AUTO_CREATE_STATISTICS OFF
	GO
	--Will automatically create on UnitPriceDiscount Column
	--Run once without the UnitPriceDiscount statement in where
	--then run it with it.
	SELECT    c.CustomerID
			, c.AccountNumber
	FROM sales.Customer c
		INNER JOIN [Sales].[SalesOrderHeader] o
			ON c.CustomerID = o.CustomerID
		INNER JOIN [Sales].[SalesOrderDetail] od
			ON o.SalesOrderID = od.salesOrderID
		INNER JOIN [Production].[Product] p
			ON od.ProductID = p.ProductID
	WHERE c.modifieddate = '2014-09-12 11:15:07.263'
			
				AND od.unitprice < 6000
				AND UnitPriceDiscount <> 0

PRINT 'QUERY WITH STATISTICS====================================='
